/*	
**    Copyright (C) 1992  Ronin Consulting, Inc.
**
**    This program is free software; you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation; version 1.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program; if not, write to the Free Software
**    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#import "SwitchBoxInspector.h"
#import "SwitchBox.h"
#import <appkit/Application.h>
#import <appkit/TextFieldCell.h>
#import <appkit/TextField.h>
#import <appkit/Window.h>
#import <appkit/Text.h>

@implementation SwitchBoxInspector

+ finishLoading:(struct mach_header *) hdr 
{
    NIBDidLoadClass(self, hdr);
    return nil;
}

+ startUnloading
{
    NIBWillUnloadClass(self);
    return nil;
}

- init
{
    [super init];
    [NXApp loadNibSection:"SwitchBoxInspector.nib" owner:self];
    return self;
}


- ok:sender
{
   [[NXApp mainWindow] makeFirstResponder:[NXApp mainWindow]];
   [window endEditingFor:self];

   [object setDefaultPanel: [initialText intValue]];
   return[super ok:sender];
}

- revert:sender
{
   [window endEditingFor:self];
    return[super revert:sender];
}

@end
